-- MoonTimeMain.lua

-- Variablen
local NameOfProject = "MoonTime"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1/25;
local Layout
local MoonTimeObject													-- dummy fuer die Objects
local MoonTimeMainframe 												-- dummy fuer das Hauptframe
local _, playerclass = UnitClass("player");

MoonTime = {}
MoonTimeDoorKeeper = CreateFrame( "Frame", "MTDoorKeeper", UIPARENT )

local ConfigLayoutList


MoonTime_DB = {															-- default Konfiguration,
																		-- wird whrend des Variabelnladens
																		-- ueberschrieben

};


MoonTime_Layout_Liste = {}										-- enthaelt moegliche Layouts

local debugging = false

local MoonTimeMain_ready = false;
local DoorKeeperLayoutList = {}
local DoorKeeperConfigList = {}




MF_id = 8921; -- Mondfeuer
SunF_id = 93402; -- Sonnenfeuer
IS_id = 5570; -- Insektenschwarm
W_id = 5176; -- Zorn
SF_id = 2912; -- Sternenfeuer
SS_id = 78674; -- Sternensog
Lunar_id = 48518; -- Lunar
Solar_id = 48517; -- Solar
SR_id = 48505; -- Sternenregen
Treants_id = 33831; -- Treants
WP_id = 88747; -- Wildpilz
FF_id = 770; -- Feenfeuer
CA_id = 112071; -- Himmlische Ausrichtung
R_id = 774; -- Verjngung


MF_name, MF_rank, MF_icon, MF_cost, MF_isFunnel, MF_powerType, MF_castTime, MF_minRange, MF_maxRange = GetSpellInfo(MF_id); -- Mondfeuer
SunF_name, SunF_rank, SunF_icon, SunF_cost, SunF_isFunnel, SunF_powerType, SunF_castTime, SunF_minRange, SunF_maxRange = GetSpellInfo(SunF_id); -- Sonnenfeuer
IS_name, IS_rank, IS_icon, IS_cost, IS_isFunnel, IS_powerType, IS_castTime, IS_minRange, IS_maxRange = GetSpellInfo(IS_id); -- Insektenschwarm
W_name, W_rank, W_icon, W_cost, W_isFunnel, W_powerType, W_castTime, W_minRange, W_maxRange = GetSpellInfo(W_id); -- Zorn
SF_name, SF_rank, SF_icon, SF_cost, SF_isFunnel, SF_powerType, SF_castTime, SF_minRange, SF_maxRange = GetSpellInfo(SF_id); -- Sternenfeuer
SS_name, SS_rank, SS_icon, SS_cost, SS_isFunnel, SS_powerType, SS_castTime, SS_minRange, SS_maxRange = GetSpellInfo(SS_id); -- Sternensog
Lunar_name, Lunar_rank, Lunar_icon, Lunar_cost, Lunar_isFunnel, Lunar_powerType, Lunar_castTime, Lunar_minRange, Lunar_maxRange = GetSpellInfo(Lunar_id); -- Lunar
Solar_name, Solar_rank, Solar_icon, Solar_cost, Solar_isFunnel, Solar_powerType, Solar_castTime, Solar_minRange, Solar_maxRange = GetSpellInfo(Solar_id); -- Solar
SR_name, SR_rank, SR_icon, SR_cost, SR_isFunnel, SR_powerType, SR_castTime, SR_minRange, SR_maxRange = GetSpellInfo(SR_id); -- Sternenregen
Treants_name, Treants_rank, Treants_icon, Treants_cost, Treants_isFunnel, Treants_powerType, Treants_castTime, Treants_minRange, Treants_maxRange = GetSpellInfo(Treants_id); -- Treants
WP_name, WP_rank, WP_icon, WP_cost, WP_isFunnel, WP_powerType, WP_castTime, WP_minRange, WP_maxRange = GetSpellInfo(WP_id); -- Wildpilz
FF_name, FF_rank, FF_icon, FF_cost, FF_isFunnel, FF_powerType, FF_castTime, FF_minRange, FF_maxRange = GetSpellInfo(FF_id); -- Feenfeuer
CA_name, CA_rank, CA_icon, CA_cost, CA_isFunnel, CA_powerType, CA_castTime, CA_minRange, CA_maxRange = GetSpellInfo(CA_id); -- Himmlische Ausrichtung
R_name, R_rank, R_icon, R_cost, R_isFunnel, R_powerType, R_castTime, R_minRange, R_maxRange = GetSpellInfo(R_id); -- Verjngung





function MoonTime.debug ( self, msg )							-- Beginn debug
	if debugging then 													-- falls debugging aktiv ist
		DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject.."(debug):|r "..msg)		
																		-- Einfache Routine zur Ausgabe von Informationen
	end
end																		-- Ende debug

function MoonTime.echo( self, msg )												-- Beginn echo
																		-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)

end	

																-- Ende echo

																
																
function MoonTime.help( self )															-- Beginn help
	--InterfaceOptionsFrame_OpenToCategory("noBrainShift")
	InterfaceOptionsFrame_OpenToCategory("MoonTime")
	--InterfaceOptionsFrame_OpenToCategory("noBrain")
--	MoonTime:echo("Version "..version.."")
--	MoonTime:echo("|cffFFFF00/moontime move|r makes the frame moveable")
--	MoonTime:echo("|cffFFFF00/moontime setlayout <name>|r sets the layout and the trashlayout")
--	MoonTime:echo("|cffFFFF00/moontime settrashlayout name|r sets the trashlayout")
--	MoonTime:echo("|cffFFFF00/moontime list|r gives a list of all layouts available")
--	MoonTime:echo("|cffFFFF00/moontime 4t11|r toggles between normal and 4-piece tier 11 rotation")
--	MoonTime:echo("|cffFFFF00/moontime toggletrash|r toggles visibility while fighting non elite mobs ")
--	MoonTime:echo("|cffFFFF00/moontime settrashhp <raidsize> <value>|r sets the mark for each raidsize (5,10,25) from where a mob is treated as a boss")
end			

function MoonTime.list( self )										-- lists the layouts
	MoonTime:echo ("Available layouts:")
	for index, value in pairs(MoonTime_Layout_Liste) do
		MoonTime:echo(index)
	end	
end	



function MoonTime.canuse( self)
	local name = GetSpellInfo(24858)
	local moonkin = UnitBuff("player", name) 
	
	if moonkin and UnitLevel("player")>=85 then
		return true
	else
		return false
	end
end



function MoonTime.registerMoonTimeLayout( self, frame )
	-- Die Moeglichkeit fr Layouts, sich einzutragen
	local _, playerclass = UnitClass("player");
	if playerclass == "DRUID" and frame.ID then
		MoonTime_Layout_Liste[frame.ID] = frame;
		frame.Mainframe = MoonTimeMainframe
		frame.Objectframe = MoonTimeObject
		MoonTime:debug("Layout \""..frame.ID.."\" has been registered.")
		MoonTime:CreateMoonTimeLayoutNow(frame.ID);

	end
end

function MoonTime.setLayout( self, layoutName )
	local oldLayout = MoonTime_DB["layout"]								-- altes Layout wird behalten wegen Loeschen
	if MoonTime_Layout_Liste[layoutName] then							-- falls es das Layout gibt
		MoonTime_DB["layout"] = layoutName
		MoonTimeMainframe:SetScript("OnUpdate", nil);					-- Update wird unterbunden waehrend des Wechsels
			if MoonTime_Layout_Liste[oldLayout] then						-- altes Layout loeschen, falls existent
				MoonTime_Layout_Liste[oldLayout]:deleteLayout()
			end
		MoonTime:CreateMoonTimeLayout(MoonTime_DB["layout"])						-- neues Layout erstellen
		
		if MoonTime:canuse() and UnitCanAttack("player","target") and not ( UnitIsDead("target") or UnitIsCorpse("target") or UnitInVehicle("player") ) then
			MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Show()
			MoonTimeMainframe:Show();
		end

		
		MoonTime:debug( "Layout \"" .. layoutName .. "\" is set");
	else
		MoonTime:debug( "Layout \"" .. layoutName .. "\" is not known. Type |cffFFFF00/moontime list|r to get all available layouts");
	end
end



function MoonTime.CreateMoonTimeLayoutNow( self, name )
	if ( name == MoonTime_DB["layout"] ) then
		MoonTime:CreateMoonTimeLayout(MoonTime_DB["layout"])								-- Layout wird erstellt
	end
end

function MoonTime.OnEvent( self, event, name, ...)										-- Beginn OnEvent
	if event=="VARIABLES_LOADED" then									-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
																		
																		
		MoonTime:UpdateDB()

																		
		MoonTimeObject = MoonTimeLayoutObj()

		ConfigLayoutList = MoonTimeBuildConfig()
		ConfigLayoutList.mainFrame = MoonTimeMainframe;
		

		
		
		--MoonTime:help()
		--MoonTime:echo("Config im Autostart")

																		
		EventFrame:RegisterEvent("PLAYER_REGEN_DISABLED");				-- Spieler beginnt Kampf
		EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");				-- Spieler verlaesst Kampf
		EventFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
		EventFrame:RegisterEvent("UNIT_COMBAT");
		EventFrame:RegisterEvent("UNIT_TARGET");
																		-- MoonTimeMainframe wird positioniert
		MoonTimeMainframe:SetPoint(MoonTime_DB["position"]["point"], nil, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"])
		

		MoonTimeMain_ready = true;
	elseif event=="PLAYER_TARGET_CHANGED" or event=="PLAYER_REGEN_DISABLED" or event=="UNIT_COMBAT" or event=="UNIT_TARGET" then	


		if MoonTime:canuse() and UnitCanAttack("player","target") and not ( UnitIsDead("target") or UnitIsCorpse("target") or UnitInVehicle("player") ) then
			
			EventFrame:UnregisterEvent("UNIT_COMBAT");
			EventFrame:UnregisterEvent("UNIT_TARGET");

			MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Show()
			MoonTimeMainframe:Show();
		else
			MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Hide()
			if not EventFrame:IsEventRegistered("UNIT_TARGET") then
				EventFrame:RegisterEvent("UNIT_COMBAT");
				EventFrame:RegisterEvent("UNIT_TARGET");
			end
		
			MoonTimeMainframe:Hide();
		end		
	end
end																		-- Ende OnEvent


function MoonTime.UpdateDB ()
	defaultDB = {
		["position"] = {	
			["point"] = "CENTER",
			["relativeTo"] = UIPARENT,
			["relativePoint"] = "CENTER",
			["offsetX"] = 0,
			["offsetY"] = 0,
		},
		["layout"] = "default",
		["enabled"] = true,
	};

	for value in pairs(defaultDB) do
		if MoonTime_DB[value] == nil then
			MoonTime_DB[value] = defaultDB[value]
		end
	end

	defaultDB = {};
	defaultDB = {
		["boxtextposi"] = 0,
		["blink_factor"] = 8,
		["blink_time_descale"] = 0.15,
		["blinkspells"] = {
			[SS_icon] = true,
			[MF_icon] = true,
			[SunF_icon] = true,
			[W_icon] = false,
			[SF_icon] = false,
		},
		["rotation"] = "default";
		["default"] = "function mynext(frame)\n\nlocal spell, _, _, _, startTime, endTime, _, castID, _ = UnitCastingInfo(\"player\");\nlocal EDir, EPower = frame:GetEclipseDirection();\n\nif endTime == nil then endTime = 0 end\nif startTime == nil then startTime = 0 end\n\nlocal castduration = max(endTime/1000 - startTime/1000,1.5);\n\nlocal gcdstart, gcd = GetSpellCooldown(8921);\ngcd = max(gcdstart+gcd-GetTime(),0);\nlocal casttime = max(endTime/1000 - GetTime()+0.01, gcd);\n\nlocal haste = UnitSpellHaste(\"player\")\nlocal tickLength = 2/(1+haste/100)\n\n\n\nEPower = frame:getFuturePower(spell, EDir, EPower);\n--MoonTime:echo(EPower)\n\nlocal Inc_CD = frame:GetTalentCD(11) ;\nlocal CA_CD = frame:GetCelestialAlignmentCD();\nlocal CA_Duration = frame:GetCelestialAlignmentDuration();\n\nlocal MF_CD, MF_Duration = frame:GetMoonfireCD();\nlocal MF_Start = MF_CD+GetTime()-MF_Duration;\nlocal SunF_CD, SunF_Duration = frame:GetSunfireCD();\nlocal SunF_Start = SunF_CD+GetTime()-SunF_Duration;\nlocal SR_Duration = frame:GetStarfallDuration();\nlocal SR_CD = frame:GetStarfallCD();\nlocal isSolar = frame:isSolar();\nlocal isLunar = frame:isLunar();\nlocal SS_CD = frame:GetStarsurgeCD();\n\n\nif Inc_CD > 150 and CA_CD <= 0 then\n  if  (EDir == \"sun\" and EPower >= 0) or (EDir == \"moon\" and EPower <= 0) then\n    return CA_icon\n  end\nend\n\n\n\nif CA_Duration > casttime then\n  local CA_Start = CA_Duration+GetTime()-15;\n\n  if (MF_Start+SunF_Start)/2<=CA_Start then\n    return MF_icon\n  end\nend\n\n\nif CA_Duration > casttime and CA_Duration < casttime+castduration and MF_CD < 4*tickLength then \n  return MF_icon\nend\n\n\nif SR_Duration <= casttime and SR_CD <= casttime then\n  return SR_icon\nend\n\nif EDir ==\"moon\" and EPower <= -100 and SR_Duration <= casttime then\n  return SR_icon\nend\n\nif (EDir == \"sun\" and EPower >= 100) or isSolar then\n  if MF_CD <= casttime+tickLength then\n    return MF_icon\n  end\n  if SunF_CD <= casttime+tickLength then\n    return SunF_icon\n  end\nend\n\nif (EDir == \"moon\" and EPower <= -100) or isLunar then\n  if SunF_CD < casttime+tickLength then\n    return SunF_icon\n  end\n  if MF_CD < casttime+tickLength then\n    return MF_icon\n  end\nend\n\nif EDir == \"moon\" and SunF_CD<casttime then\n  return SunF_icon\nend\n\nif EDir == \"sun\" and MF_CD<casttime then\n  return MF_icon\nend\n\n\nif SS_CD <= casttime and spell ~=SS_name then\n  -- only one Starsurge per Solar\n  if not (isSolar and EPower > 5 and (EPower/5)%3 == 1) then\n    return SS_icon\n  end\nend\n\nif EDir == \"moon\" and spell ~= nil and EPower <= -100 then\n  return SF_icon\nend\n\nif EDir == \"sun\" and spell ~= nil and EPower >=100 then\n  return W_icon\nend\n\nif EDir == \"moon\" then\n    return W_icon\nend\n\nreturn SF_icon\n\n\n\nend",
		["custom1"]  = "function mynext(frame)\n\n  return IS_icon\n\nend";
		["custom2"]  = "function mynext(frame)\n\n  return IS_icon\n\nend";
		["default_posi"] = 0;
		["custom1_posi"] = 0;
		["custom2_posi"] = 0;
	}
		
	if not MoonTime_DB["Layout_noBrain"] then
		MoonTime_DB["Layout_noBrain"] = {}
	end
		
	MoonTime_DB["Layout_noBrain"]["default"] = nil
		
	if MoonTime_DB["Layout_noBrain"]["custom1"] == nil and MoonTime_DB["Layout_noBrain"]["boxtext"] ~= nil then
		MoonTime_DB["Layout_noBrain"]["custom1"] = MoonTime_DB["Layout_noBrain"]["boxtext"]
	end
		
	for value in pairs(defaultDB) do
		if MoonTime_DB["Layout_noBrain"][value] == nil then
			MoonTime_DB["Layout_noBrain"][value] = defaultDB[value]
		end
	end
end






function MoonTime.enable()														-- Beginn enable
end																		-- Ende enable

function MoonTime.disable()														-- Beginn enable
end																		-- Ende enable

function MoonTime.move( self )															-- Beginn config
	MoonTimeMainframe:SetBackdropColor(1,0,0,1)
	MoonTimeMainframe:SetMovable(true)
	MoonTimeMainframe:EnableMouse(true)
	MoonTimeMainframe.isLocked = false
	MoonTimeMainframe:Show()
end																		-- Ende config

function MoonTime.setPosition( self )															-- Beginn config
	MoonTimeMainframe:SetMovable(false)
	MoonTimeMainframe:EnableMouse(false)
	MoonTimeMainframe.isLocked = true
	
	MoonTimeMainframe:ClearAllPoints()
	MoonTimeMainframe:SetPoint(MoonTime_DB["position"]["point"], UIPARRENT, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"])
end	


function MoonTime.toggle(self, msg)													-- Beginn toggle
	origMsg = msg
	msg = strtrim( msg )												-- entferne ueberfluessige whitespaces
	msg = msg:lower()													-- in Kleinbuchstaben verwandeln
	if( msg == "help" ) then MoonTime:help()										-- rufe help auf
	elseif( msg == "move" ) then MoonTime:move()									-- rufe move auf
								-- rufe enable auf
	elseif( msg == "reset" ) then MoonTime_DB=""; ReloadUI()
	else
		MoonTime:help()
	end
end																		-- Ende toggle

function MoonTime.OnUpdate(self, elapsed)										-- Beginn OnUpdate
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	

  while (TimeSinceLastUpdate > UpdateFrequency) do
		-- wie bei create wird dies umgeschrieben, dass die jeweils zutreffende Function angesprochen wird
		--MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Update()
		--echo (MoonTime_Layout_Liste[MoonTime_DB["layout"]].ID)
		MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Update()
    TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateFrequency;
  end

end																		-- Ende OnUpdate
function MoonTime.CreateMainFrame ( self )					
	
	local frame = CreateFrame( "Frame", "MTMainframe", UIPARENT )
	frame:SetMovable(false)
	frame:EnableMouse(false)
	frame:SetClampedToScreen(true)
	frame:SetBackdrop({
		bgFile = "",
		tile = true, tileSize = height, edgeSize = 10,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	frame.isLocked = true
	frame:SetScript("OnMouseDown", 
			function(self, button)
				if ( ( ( not self.isLocked ) or ( self.isLocked == 0 ) ) and ( button == "LeftButton" ) ) then
					self:StartMoving();
					self.isMoving = true;
				end
			end
		)
	frame:SetScript("OnMouseUp", 
			function(self)
				if ( self.isMoving ) then
					self:StopMovingOrSizing();
					self.isMoving = false;
					
																				-- falls die Position gespeichert werden soll
	p,_,pt,x,y = MoonTimeMainframe:GetPoint();																			
	local c = 0;
	local d = 0;
	local a = 0;
	local b = 0;
	
	if ( string.find(p, "LEFT") ) then
		a=1;
	elseif ( string.find(p, "RIGHT") ) then
		a=-1;
	end
	
	if ( string.find(p, "TOP") ) then
		b=-1;
	elseif ( string.find(p, "BOTTOM") ) then
		b=1;
	end
	
	while not ( p == "CENTER" or p == "TOP" or p == "BOTTOM" ) do
		MoonTimeMainframe:SetPoint(p, UIPARRENT, pt, x+a, y)
		self:StartMoving();
		self:StopMovingOrSizing();
		c = c+1;
	
		p,_,pt,x,y = MoonTimeMainframe:GetPoint();	
	end
	
	while not ( p == "CENTER" or p == "LEFT" or p == "RIGHT" ) do
		MoonTimeMainframe:SetPoint(p, UIPARRENT, pt, x, y+b)
		self:StartMoving();
		self:StopMovingOrSizing();
		d = d+1;
	
		p,_,pt,x,y = MoonTimeMainframe:GetPoint();	
	end

	MoonTimeMainframe:ClearAllPoints()
	MoonTimeMainframe:SetPoint("CENTER", UIPARRENT, "CENTER", x-a*c, y-b*d)
																				
					MoonTime_DB["position"]["point"], _, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"] = frame:GetPoint(1)															
																				
																				
					self:SetMovable(false)
					self:EnableMouse(false)
					self.isLocked = true
					self:SetBackdropColor(1,0,0,0)
				end
			MoonTime_DB["position"]["offsetX"]= floor(MoonTime_DB["position"]["offsetX"])
			MoonTime_DB["position"]["offsetY"]= floor(MoonTime_DB["position"]["offsetY"])
			InterfaceOptionsFrame_OpenToCategory("MoonTime")
			end
		)
	
	frame:SetHeight(50)
	frame:SetWidth(50)
	frame:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background"})
	frame:SetBackdropColor(1,0,0,0)
	frame:EnableMouse(false)
	frame:SetPoint("CENTER", UIPARENT, "CENTER", 0, 0)
	return frame
	
end

function MoonTime.CreateMoonTimeLayout( self, which )											-- Beginn CreateFrame
	if MoonTime_Layout_Liste[which] then 
		MoonTime_Layout_Liste[which]:createLayout(MoonTimeMainframe);
		MoonTime:debug("Layout \""..which.."\" loaded.")
	end

	MoonTimeMainframe:SetScript("OnUpdate", function(self, event, ... ) MoonTime:OnUpdate(event, ...) end)					-- Seine UpdateRoutine wird angeworfen
																		-- Da die Updateroutine nur dann angeworfen wird, wenn das Fenster
																		-- sichtbar ist, wird OnUpdate auch nur dann aufgerufen, wenn es gebraucht
																		-- wird

end																		-- Ende CreateFrame


function MoonTime.initialize(self)													-- Beginn initialize

	SlashCmdList["MOONTIME"] = function( msg ) MoonTime:toggle( msg ) end
	SLASH_MOONTIME1 = "/moontime";
	SLASH_MOONTIME2 = "/moon";
	
	EventFrame = CreateFrame( "Frame", "MTEventframe", UIPARENT	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) MoonTime:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	MoonTimeMainframe = MoonTime:CreateMainFrame()								-- Das Hauptfenster wird erzeugt
	MoonTimeMainframe:Show()
	--MoonTimeObject = MoonTimeLayoutObj()
	MoonTime:echo("initialized...")

end	

-- Ende initialize

function MoonTime.LetAllIn(self)
	for number, frame in pairs(DoorKeeperLayoutList) do
		MoonTime:registerMoonTimeLayout(frame)
	end
	for number, frame in pairs(DoorKeeperConfigList) do
		frame.createConfig(ConfigLayoutList)
	end
end

	
MoonTimeDoorKeeper.RegisterLayout = function(self, frame, ... ) 
	if playerclass == "DRUID" then 
		if not MoonTimeMain_ready then
			tinsert(DoorKeeperLayoutList, frame)
		else
			MoonTime:registerMoonTimeLayout(frame, ...) 
		end
	end 
end
MoonTimeDoorKeeper.RegisterConfig = function(self, frame, ...) 
	if playerclass == "DRUID" then 
		if not MoonTimeMain_ready then
			tinsert(DoorKeeperConfigList, frame)
		else
			frame.createConfig(ConfigLayoutList) 
		end
	end 
end



MoonTimeDoorKeeper:SetScript("OnUpdate", function(self) if MoonTimeMain_ready then MoonTimeDoorKeeper:SetScript("OnUpdate", nil) MoonTime:LetAllIn()  end end);



-- Hilfsfunktionen zum Erstellen von Frames

function MoonTime.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function MoonTime.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
		fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		fontstring:SetWidth(width)
		fontstring:SetHeight(height)
		fontstring:SetJustifyH(justifyH)
		fontstring:SetJustifyV(justifyV)
		fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end


if playerclass == "DRUID" then
	MoonTime:initialize()															-- make it so!
end



